* Program ...: EmLookup.PRG
* Author ....: Chuck Litzell
* Date ......: June 1, 1988
* Notes .....: Sample program to demonstrate ways to use Secure.BIN.
*
SET TALK OFF
LOAD Secure
CLEAR
* ---This program should be dBCODEd so that the hard-coded passwords
* ---below can't be read. A password can contain any sequence
* ---of at least eight characters. Upper- and lowercase are
* ---not distinguished.
supers = "RKBRed Dogs, LMTI Luv NY"
* ---You only get 3 tries!
tries = 0
DO WHILE .T.
   * ---Identify the supervisor and get password.
   msuper = SPACE(3)
   @ 13, 13 TO 16, 38 DOUBLE
   @ 14, 15 SAY "Supervisor " GET msuper PICTURE "@! AAA"
   @ 15, 15 SAY "Password"
   READ
   * ---Get password without displaying characters.
   mpassw = ""
   @ 15, 27 SAY ""
   DO WHILE .T.
      key = 0
      DO WHILE key = 0
         key = ABS(INKEY())
      ENDDO
      DO CASE
      CASE key = 127
         IF LEN(mpassw) > 0
            * ---Handle Backspace.
            mpassw = LEFT(mpassw, LEN(mpassw) - 1)
         ENDIF
      CASE key = 13
         * ---End of password entry.
         EXIT
      OTHERWISE
         * ---Add the keystroke to the password.
         mpassw = mpassw + CHR(key)
      ENDCASE
      * ---Display template of characters entered, and
      * ---reposition the cursor.
      @ 15, 27 SAY REPLICATE(CHR(254), LEN(mpassw)) + " "
      @ 15, COL() - 1 SAY ""
   ENDDO
   * ---Look up the password in the list of supervisors.
   IF .NOT. UPPER(msuper + mpassw) $ UPPER(supers)
      tries = tries + 1
      @ 24, 0 SAY "Invalid password. "
      IF tries < 3
         * ---Go back for another try.
         @ ROW(), COL() SAY "Try Again"
         LOOP
      ELSE
         * ---No more chances. Quit!
         @ ROW(), COL() SAY "Quitting"
         QUIT
      ENDIF
   ENDIF
   EXIT
ENDDO
USE Workers
* ---Background Screen.
CLEAR
@  4,  7 SAY "Employee First Name"
@  5,  7 SAY "Employee Last Name"
@  6,  7 SAY "Date Hired"
@  7,  7 SAY "Department"
@  8,  7 SAY "Supervisor"
@  9,  7 SAY "Salary"
@  4, 27 TO  9, 27
@  3,  5 TO 10, 45
DO WHILE .T.
   @  4, 29 CLEAR TO 9, 44
   * ---Enter employee to look up, or Press Esc to quit.
   mfirst = SPACE(10)
   mlast  = SPACE(10)
   @  4, 29 GET mfirst
   @  5, 29 GET mlast
   @ 24,  0
   @ 24,  0 SAY "Enter Employee to Look Up. Press Esc to Quit."
   READ
   IF READKEY() = 12
      * ---Escape or Ctrl-Q were pressed.
      CLOSE DATABASES
      RELEASE MODULE SECURE
      RETURN
   ENDIF
   @ 24, 0
   * ---Search for the requested employee.
   GO TOP
   LOCATE FOR UPPER(Firstname) = UPPER(mfirst) .AND. ;
              UPPER(Lastname)  = UPPER(mlast)
   IF EOF()
      @ 24, 0 SAY "Can't find that Employee. Try Again."
      LOOP
   ENDIF
   IF msuper <> Supervisor
      * ---If this isn't one of the super's employees, just
      * ---display the info. No edits allowed.
      @ 4, 29 SAY Firstname
      @ 5, 29 SAY Lastname
      @ 6, 29 SAY Hired
      @ 7, 29 SAY Dept
      @ 8, 29 SAY Supervisor
      @ 9, 29 SAY Salary
      @ 24, 0 SAY "Press a key to continue"
      * ---Wait for a key.
      DO WHILE INKEY() = 0
      ENDDO
   ELSE
      * ---This is one of the supervisor's employees.
      * ---decrypt Salary, and make fields editable.
      msalary = Salary
      DO Encrypt WITH mpassw, msalary
      @  4, 29 GET Firstname
      @  5, 29 GET Lastname
      @  6, 29 GET Hired
      @  7, 29 GET Dept
      @  8, 29 SAY Supervisor    && Must be changed by DP Manager
      * ---Convert to numeric for display and edit.
      nsalary = VAL(msalary)
      @  9, 29 GET nsalary PICTURE "999999.99"
      READ
      * ---Then convert back to character, re-encrypt and put it
      * ---back in the field.
      msalary = STR(nsalary, 9, 2)
      DO Encrypt WITH mpassw, msalary
      REPLACE Salary WITH msalary
   ENDIF
ENDDO
* EOP: EmLookup.PRG
