* Program ...: Encrypt.PRG
* Author ....: Cathy Shikatani
* Date ......: June 1, 1988
* Notes .....: Uses Secure.BIN to encrypt a character memory variable passed
*              as a parameter. Secure is called in two passes, so it's less
*              likely that the key can be discovered from an examination of
*              the encrypted data. Data will not be encrypted if the key is
*              less than 8 characters, or if it contains only spaces.
*
PARAMETERS key, cdata
IF "" = TRIM(cdata) .OR. LEN(TRIM(key)) < 8
   RETURN
ENDIF
* ---The key and data-to-encrypt must be stored to consecutive
* ---memory variables for Secure to work.
mkey  = key
mdata = cdata
* ---Call Secure the first time, then rearrange the characters
* ---of the password and call it a second time. "AABBCCDD" becomes
* ---"CCAADDBB" on the second pass.
CALL Secure WITH mkey
mkey  = STUFF(mkey, 1, 8, ;
        SUBSTR(mkey, 5, 2) + SUBSTR(mkey, 1, 2) + ;
        SUBSTR(mkey, 7, 2) + SUBSTR(mkey, 3, 2))
CALL Secure WITH mkey
cdata = mdata
RETURN
* ---EOP:  Encrypt.PRG.
